--- fileutils-4.1.9/src/chmod.c.bero	Fri Aug 30 00:40:18 2002
+++ fileutils-4.1.9/src/chmod.c	Fri Aug 30 00:43:40 2002
@@ -181,6 +181,19 @@
 	       quote (file));
       errors = 1;
     }
+  else
+    {
+      // Make sure the permissions are correct now (the kernel might strip
+      // off setuid/setgid
+      struct stat st;
+      stat(file, &st);
+      if((newmode & 07777) != (st.st_mode & 07777))
+        {
+	  if (force_silent == 0)
+            error (0, EPERM, _("changing permissions of %s (requested: %04o, actual: %04o)"), quote (file), newmode & 07777, st.st_mode & 07777);
+          errors = 1;
+        }
+    }
 
   if (recurse && S_ISDIR (file_stats.st_mode))
     errors |= change_dir_mode (file, changes);
